﻿//// Star Layer ver2.0 (2013.2.10)
//// 星空生成ツール Illustrator用

//別ファイル関数の読み込み
#include "./function/Form.jsxinc"

#include "./function/star65_transform_and_place.jsxinc"
#include "./function/star_milkyway_transform_and_place.jsxinc"

#include "./function/milkyway_transform.jsxinc"
#include "./function/milkyway_transform_sample2px.jsxinc"

#include "./function/milkyway_place_mono.jsxinc"
#include "./function/milkyway_place_multi.jsxinc"


(function(){
    
//----前回入力値設定----

    //作業フォルダの読み込み
         foldername = File($.fileName).parent.fsName;
    //前回入力値ファイルの読み込み  
            UIFileX1  = new File(foldername+"/star_layer_data/UIdata.txt");
            UIFileX1.open("r");
            fileUIX1 = UIFileX1.read();
            UI_in = fileUIX1.split(",");  
            UIFileX1.close();
delete fileUIX1;

    //前回入力値設定
        var dlg = new Form;
        dlg.list_data_type.selection = UI_in[0];        
        dlg.textBox_comp_W.text = UI_in[1];
        dlg.textBox_comp_H.text  = UI_in[2];
        dlg.textBox_year.text = UI_in[3];
        dlg.textBox_month.text = UI_in[4];
        dlg.textBox_day.text = UI_in[5];
        dlg.textBox_time.text = UI_in[6];
        dlg.textBox_minute.text = UI_in[7];
        dlg.textBox_longitude.text = UI_in[8];
        dlg.textBox_latitude.text = UI_in[9];
        dlg.textBox_UTC_gap_time.text = UI_in[10];
        dlg.textBox_UTC_gap_minute.text = UI_in[11];        
        dlg.textBox_dir.text = UI_in[12];
        dlg.slider_dir.value = UI_in[12];     
        dlg.textBox_star_bright.text = UI_in[13];
        dlg.label_star_db.text = UI_in[13];  
        dlg.textBox_star_dark.text = UI_in[14];
        dlg.textBox_milkyway_star.text = UI_in[16];
        dlg.textBox_star_size.text = UI_in[18];
        dlg.textBox_star_color.text = UI_in[20];
     
    if(UI_in[15] == "true"){
        dlg.checkbox_milkyway_star.value = true;
        }
    else if(UI_in[15] == "false"){
        dlg.checkbox_milkyway_star.value = false;
        }

    if(UI_in[17] == "true"){
        dlg.checkbox_milkyway_image.value = true;
        }
    else if(UI_in[17] == "false"){
        dlg.checkbox_milkyway_image.value = false;
        }
    
    if(UI_in[19] == "true"){
        dlg.checkbox_star_color.value = true;
        }
    else if(UI_in[19] == "false"){
        dlg.checkbox_star_color.value = false;
        }
    
	if(UI_in[0] == 0){
     dlg.checkbox_milkyway_image.enabled = false;
     dlg.label_comp_Wmm.text = "mm";        
     dlg.label_comp_Hmm.text = "mm";
        }
	else if(UI_in[0] == 1){
    dlg.checkbox_milkyway_image.enabled = true;        
    dlg.label_comp_Wmm.text = "px";
    dlg.label_comp_Hmm.text = "px";    
		}
	

//入力中エラー処理関数定義
 function error_changing (textBox, min , max ){
	var value_in = textBox; 
        if(!(value_in =="")){
            if(value_in<min){
                value_in = min;
                textBox = value_in;
                return textBox;
                }
            else if(value_in>max){
                value_in = max;
                textBox = value_in;
                return textBox;
                }
        }
    textBox = "remain"; 
    return textBox;
}


//入力後エラー処理関数定義
 function error_change (textBox , min , max , text , di_j ){
    var value_in = textBox;
	if(value_in ==""){
		alert("「"+text+"」に値を入力して下さい。");
		}
	else if(isNaN(value_in) == false){
            if(di_j == 0){
                textBox = parseFloat(value_in);                
            }
            else if(di_j == 1){
                textBox = Math.round(value_in);                
            }  
            return textBox;
		}
	else if(isNaN(value_in) == true){
            var text_di
            if(di_j == 0){
                text_di ="数字";
                }
            else if(di_j == 1){
                text_di ="整数";
                }                 
		alert("「" + text +"」には" + min +"～" + max + "の半角" + text_di + "を入力して下さい。");
		}   
    textBox = ""; 
    return textBox;
}


//----データ形式読み取り----
dlg.list_data_type.onChange = function(){
    
var vr_j_in = dlg.list_data_type.selection;
vr_j_in = parseFloat (vr_j_in);
	if(vr_j_in == 0){
     dlg.checkbox_milkyway_image.enabled = false;
     dlg.label_comp_Wmm.text = "mm";        
     dlg.label_comp_Hmm.text = "mm";
        }
	else if(vr_j_in == 1){
    dlg.checkbox_milkyway_image.enabled = true;        
    dlg.label_comp_Wmm.text = "px";
    dlg.label_comp_Hmm.text = "px";    
		}
	}

//----出力サイズ読み取り----
//出力サイズ幅
var textBox_comp_W_min = 1;
var textBox_comp_W_max = 9999;

dlg.textBox_comp_W.onChanging = function(){
    var textBox_comp_W_changing = error_changing (dlg.textBox_comp_W.text, textBox_comp_W_min , textBox_comp_W_max );
        if (!(textBox_comp_W_changing =="remain")){
            dlg.textBox_comp_W.text = textBox_comp_W_changing;
            }
}

dlg.textBox_comp_W.onChange = function(){
	var pixel_width_in = dlg.textBox_comp_W.text;
    var vr_j_in = dlg.list_data_type.selection;
    vr_j_in = parseFloat (vr_j_in);
	
    if(pixel_width_in ==""){
		alert("「出力サイズW」に値を入力して下さい。");
		}
	else if(isNaN(pixel_width_in) == false){
        if(vr_j_in == 0){
            dlg.textBox_comp_W.text = parseFloat(pixel_width_in);
        }
        else if(vr_j_in == 1){
            dlg.textBox_comp_W.text = Math.round(pixel_width_in);
        }    
	}
	else if(isNaN(pixel_width_in) == true){
        if(vr_j_in == 0){        
            alert("「出力サイズW」には1～9999の半角数字を入力して下さい。");
        }
        else if(vr_j_in == 1){        
            alert("「出力サイズW」には1～9999の半角整数を入力して下さい。");
        }    
	}
}


//出力サイズ高さ
var textBox_comp_H_min = 1;
var textBox_comp_H_max = 9999;

dlg.textBox_comp_H.onChanging = function(){
    var textBox_comp_H_changing = error_changing (dlg.textBox_comp_H.text, textBox_comp_H_min , textBox_comp_H_max );
        if (!(textBox_comp_H_changing =="remain")){
            dlg.textBox_comp_H.text = textBox_comp_H_changing;
            }
}

dlg.textBox_comp_H.onChange = function(){	
	var pixel_height_in = dlg.textBox_comp_H.text;
    var vr_j_in = dlg.list_data_type.selection;
    vr_j_in = parseFloat (vr_j_in);
    
	if(pixel_height_in ==""){
		alert("「出力サイズH」に値を入力して下さい。");
		}
	else if(isNaN(pixel_height_in) == false){
        if(vr_j_in == 0){        
            dlg.textBox_comp_H.text = parseFloat(pixel_height_in);
        }    
        else if(vr_j_in == 1){        
            dlg.textBox_comp_H.text = Math.round(pixel_height_in);
        }    
	}
	else if(isNaN(pixel_height_in) == true){
        if(vr_j_in == 0){        
            alert("「出力サイズH」には1～9999の半角数字を入力して下さい。");
        }
        else if(vr_j_in == 1){        
            alert("「出力サイズH」には1～9999の半角整数を入力して下さい。");
        }    
	}
}

//----日時読み取り----
//年
var textBox_year_min = 1;
var textBox_year_max = 2100;

dlg.textBox_year.onChanging = function(){
    var textBox_year_changing = error_changing (dlg.textBox_year.text, textBox_year_min , textBox_year_max );
        if (!(textBox_year_changing =="remain")){
            dlg.textBox_year.text = textBox_year_changing;
            }
}

dlg.textBox_year.onChange = function(){
	var year_in = dlg.textBox_year.text;

	if(year_in ==""){
		alert("「年」に値を入力して下さい。");
		}
	else if(isNaN(year_in) == false){
		year_in = Math.round(year_in);
		dlg.textBox_year.text = year_in;
			if(!(1900<=year_in && year_in<=2100)){
			alert("「年」には1900～2100の半角整数を入力して下さい。");
			}
		}
	else if(isNaN(year_in) == true){
		alert("「年」には1900～2100の半角整数を入力して下さい。");
		}
	}

//月
var textBox_month_min = 1;
var textBox_month_max = 12;
var textBox_month_text = "月";
var textBox_month_di_j = 1;

dlg.textBox_month.onChanging = function(){
    var textBox_month_changing = error_changing (dlg.textBox_month.text, textBox_month_min , textBox_month_max );
        if (!(textBox_month_changing =="remain")){
            dlg.textBox_month.text = textBox_month_changing;
            }
}

dlg.textBox_month.onChange = function(){
    dlg.textBox_month.text = error_change (dlg.textBox_month.text , textBox_month_min , textBox_month_max , textBox_month_text  , textBox_month_di_j );
}   

//日
dlg.textBox_day.onChanging = function(){
	var year_in = dlg.textBox_year.text;
	var month_in = dlg.textBox_month.text;    
	var day_in = dlg.textBox_day.text; 
	
	if((1900<=year_in && year_in<=2100) && (1<=month_in && month_in<=12)){
		year_in = dlg.textBox_year.text;
		month_in = dlg.textBox_month.text;
		
				if(month_in == 1 ||month_in == 3 || month_in == 5 ||month_in == 7 ||month_in == 8 ||month_in == 10 || month_in == 12 ){
					if(!(day_in =="")){
						if(day_in<1){
							day_in = 1;
							dlg.textBox_day.text = day_in;
								}
						else if(day_in>31){
							day_in = 31;
							dlg.textBox_day.text = day_in;
								}
						}
				}
		
				else if(month_in == 4 ||month_in == 6 || month_in == 9 ||month_in == 11){
					if(!(day_in =="")){		
						if(day_in<1){
							day_in = 1;
							dlg.textBox_day.text = day_in;
								}
						else if(day_in>30){
							day_in = 30;
							dlg.textBox_day.text = day_in;
								}
						}
				}
				else if(month_in == 2){
					if(!(day_in =="")){					
						if(day_in<1){
							day_in = 1;
							dlg.textBox_day.text = day_in;
							}
						else if(day_in>28){
									if(year_in%400 == 0){
											day_in = 29;
											dlg.textBox_day.text = day_in;
									}
									else if(year_in%100 == 0){
											day_in = 28;
											dlg.textBox_day.text = day_in;
									}
									else if(year_in%4 == 0){
											day_in = 29;
											dlg.textBox_day.text = day_in;
									}
									else{
											day_in = 28;
											dlg.textBox_day.text = day_in;
									}	
							}
					}
				}	
		
		}
	else if(!(1900<=year_in && year_in<=2100)){
		alert("「年」には1900～2100の半角整数を入力して下さい。");
		}
	else if(!(1<=month_in && month_in<=12)){
		alert("「月」には1～12の半角整数を入力して下さい。");
		}
}

dlg.textBox_day.onChange = function(){
	var day_in = dlg.textBox_day.text;
	if(day_in ==""){
		alert("「日」に値を入力して下さい。");			
		}
	else if(isNaN(day_in) == false){
		dlg.textBox_day.text = Math.round(day_in);
		}
	else if(isNaN(day_in) == true){
		alert("「日」には半角整数を入力して下さい。");
		}
	}


//時
var textBox_time_min = 0;
var textBox_time_max = 23;
var textBox_time_text = "時間";
var textBox_time_di_j = 1;

dlg.textBox_time.onChanging = function(){
    var textBox_time_changing = error_changing (dlg.textBox_time.text, textBox_time_min , textBox_time_max );
        if (!(textBox_time_changing =="remain")){
            dlg.textBox_time.text = textBox_time_changing;
            }
}

dlg.textBox_time.onChange = function(){
    dlg.textBox_time.text = error_change (dlg.textBox_time.text , textBox_time_min , textBox_time_max , textBox_time_text  , textBox_time_di_j );
} 


//分
var textBox_minute_min = 0;
var textBox_minute_max = 60;
var textBox_minute_text = "分";
var textBox_minute_di_j = 0;

dlg.textBox_minute.onChanging = function(){
	var time_min_in = dlg.textBox_minute.text; 
	if(!(time_min_in =="")){
		if(time_min_in<0){
			time_min_in = 0;
			dlg.textBox_minute.text = time_min_in;
				}
		else if(time_min_in>=60){
			time_min_in = 59;
			dlg.textBox_minute.text = time_min_in;
				}
		}
	}

dlg.textBox_minute.onChange = function(){
    dlg.textBox_minute.text = error_change (dlg.textBox_minute.text , textBox_minute_min , textBox_minute_max , textBox_minute_text  , textBox_minute_di_j );
} 

//----場所読み取り----
//経度
var textBox_longitude_min = -180;
var textBox_longitude_max = 180;
var textBox_longitude_text = "経度";
var textBox_longitude_di_j = 0;

dlg.textBox_longitude.onChanging = function(){
    var textBox_longitude_changing = error_changing (dlg.textBox_longitude.text, textBox_longitude_min , textBox_longitude_max );
        if (!(textBox_longitude_changing =="remain")){
            dlg.textBox_longitude.text = textBox_longitude_changing;
            }
}

dlg.textBox_longitude.onChange = function(){
    dlg.textBox_longitude.text = error_change (dlg.textBox_longitude.text , textBox_longitude_min , textBox_longitude_max , textBox_longitude_text  , textBox_longitude_di_j );
} 

//緯度
var textBox_latitude_min = -90;
var textBox_latitude_max = 90;
var textBox_latitude_text = "緯度";
var textBox_latitude_di_j = 0;

dlg.textBox_latitude.onChanging = function(){
    var textBox_latitude_changing = error_changing (dlg.textBox_latitude.text, textBox_latitude_min , textBox_latitude_max );
        if (!(textBox_latitude_changing =="remain")){
            dlg.textBox_latitude.text = textBox_latitude_changing;
            }
}

dlg.textBox_latitude.onChange = function(){
    dlg.textBox_latitude.text = error_change (dlg.textBox_latitude.text , textBox_latitude_min , textBox_latitude_max , textBox_latitude_text  , textBox_latitude_di_j );
} 

//時差（h）
var textBox_UTC_gap_time_min = -23;
var textBox_UTC_gap_time_max = 23;
var textBox_UTC_gap_time_text = "時差：時間";
var textBox_UTC_gap_time_di_j = 1;

dlg.textBox_UTC_gap_time.onChanging = function(){
    var textBox_UTC_gap_time_changing = error_changing (dlg.textBox_UTC_gap_time.text, textBox_UTC_gap_time_min , textBox_UTC_gap_time_max );
        if (!(textBox_UTC_gap_time_changing =="remain")){
            dlg.textBox_UTC_gap_time.text = textBox_UTC_gap_time_changing;
            }
}

dlg.textBox_UTC_gap_time.onChange = function(){
    dlg.textBox_UTC_gap_time.text = error_change (dlg.textBox_UTC_gap_time.text , textBox_UTC_gap_time_min , textBox_UTC_gap_time_max , textBox_UTC_gap_time_text  , textBox_UTC_gap_time_di_j );
} 

//時差（min）
var textBox_UTC_gap_minute_min = 0;
var textBox_UTC_gap_minute_max = 60;
var textBox_UTC_gap_minute_text = "時差：分";
var textBox_UTC_gap_minute_di_j = 0;

dlg.textBox_UTC_gap_minute.onChanging = function(){
	var time_gap_min_in = dlg.textBox_UTC_gap_minute.text; 
	if(!(time_gap_min_in =="")){
		if(time_gap_min_in<0){
			time_gap_min_in = 0;
			dlg.textBox_UTC_gap_minute.text = time_gap_min_in;
				}
		else if(time_gap_min_in>=60){
			time_gap_min_in = 59;
			dlg.textBox_UTC_gap_minute.text = time_gap_min_in;
				}
		}
	}

dlg.textBox_UTC_gap_minute.onChange = function(){
    dlg.textBox_UTC_gap_minute.text = error_change (dlg.textBox_UTC_gap_minute.text , textBox_UTC_gap_minute_min , textBox_UTC_gap_minute_max , textBox_UTC_gap_minute_text  , textBox_UTC_gap_minute_di_j );
} 

//----方角読み取り----
var A0_deg_in = dlg.textBox_dir.text; 

dlg.slider_dir.onChanging = function(){
	A0_deg_in = Math.round(dlg.slider_dir.value);
	dlg.textBox_dir.text = A0_deg_in;
	}

dlg.textBox_dir.onChanging = function(){
	A0_deg_in = dlg.textBox_dir.text;
	if(!(A0_deg_in =="")){	
		if(A0_deg_in<0){
			A0_deg_in = 0;
			dlg.slider_dir.value = A0_deg_in;
			dlg.textBox_dir.text = A0_deg_in;
				}
		else if(A0_deg_in>360){
			A0_deg_in = 360;
			dlg.slider_dir.value = A0_deg_in;
			dlg.textBox_dir.text = A0_deg_in;
				}
		else{
			dlg.slider_dir.value = A0_deg_in;
				}
		}
	
	}

dlg.textBox_dir.onChange = function(){
	A0_deg_in = dlg.textBox_dir.text; 
	if(A0_deg_in ==""){
		alert("「方角」に値を入力して下さい。");
	}
	else if(isNaN(A0_deg_in) == false){
		dlg.textBox_dir.text = parseFloat(A0_deg_in);
		}
	else if(isNaN(A0_deg_in) == true){
		alert("「方角」には0～360の半角数字を入力して下さい。");
		}
	}


//----一般の星読み取り----
//明るい星
var textBox_star_bright_min = -1.5;
var textBox_star_bright_max = 6.5;

dlg.textBox_star_bright.onChanging = function(){
    var textBox_star_bright_changing = error_changing (dlg.textBox_star_bright.text, textBox_star_bright_min , textBox_star_bright_max );
        if (!(textBox_star_bright_changing =="remain")){
            dlg.textBox_star_bright.text = textBox_star_bright_changing;
                    dlg.label_star_db.text = textBox_star_bright_changing; 
            }
}

dlg.textBox_star_bright.onChange = function(){
	var star_laysep_mag_in = dlg.textBox_star_bright.text;      
	var mag_min_in = dlg.textBox_star_dark.text;
	if(star_laysep_mag_in ==""){
		alert("「一般：明るい星」に値を入力して下さい。");
		}
	else if(isNaN(star_laysep_mag_in) == false){
		star_laysep_mag_in = parseFloat(star_laysep_mag_in);        
		dlg.textBox_star_bright.text = star_laysep_mag_in;
			if(!(star_laysep_mag_in<=mag_min_in)){
                alert("「一般：明るい星」には暗い星より小さい半角数字を入力して下さい。");
			}
             else{
                dlg.label_star_db.text = star_laysep_mag_in;                 
                 }
		}
	else if(isNaN(star_laysep_mag_in) == true){
		alert("「一般：明るい星」には-1.5～6.5の半角数字を入力して下さい。");
		}
}

//暗い星
var textBox_star_dark_min = -1.5;
var textBox_star_dark_max = 6.5;

dlg.textBox_star_dark.onChanging = function(){
    var textBox_star_dark_changing = error_changing (dlg.textBox_star_dark.text, textBox_star_dark_min , textBox_star_dark_max );
        if (!(textBox_star_dark_changing =="remain")){
            dlg.textBox_star_dark.text = textBox_star_dark_changing;
            }
}

dlg.textBox_star_dark.onChange = function(){
	var mag_min_in = dlg.textBox_star_dark.text;
	var star_laysep_mag_in = dlg.textBox_star_bright.text;    
	if(mag_min_in ==""){
		alert("「一般：暗い星」に値を入力して下さい。");
		}
	else if(isNaN(mag_min_in) == false){
		mag_min_in = parseFloat(mag_min_in);        
		dlg.textBox_star_dark.text = mag_min_in;
			if(!(star_laysep_mag_in<=mag_min_in)){
			alert("「一般：暗い星」には明るい星より大きい半角数字を入力して下さい。");
			}           
             else{
                dlg.label_star_db.text = star_laysep_mag_in;                 
                 }
		}
	else if(isNaN(mag_min_in) == true){
		alert("「一般：暗い星」には-1.5～6.5の半角数字を入力して下さい。");
		}
	}
			

//----天の川読み取り----
//最微等級
var textBox_milkyway_star_min = 6;
var textBox_milkyway_star_max = 8.5;

dlg.textBox_milkyway_star.onChanging = function(){
    var textBox_milkyway_star_changing = error_changing (dlg.textBox_milkyway_star.text, textBox_milkyway_star_min , textBox_milkyway_star_max );
        if (!(textBox_milkyway_star_changing =="remain")){
            dlg.textBox_milkyway_star.text = textBox_milkyway_star_changing;
            }
}

dlg.textBox_milkyway_star.onChange = function(){
	var mag_m_min_in = dlg.textBox_milkyway_star.text;

	if(mag_m_min_in ==""){
		alert("「天の川：星の等級」に値を入力して下さい。");
		}
	else if(isNaN(mag_m_min_in) == false){
		mag_m_min_in = parseFloat(mag_m_min_in);
		dlg.textBox_milkyway_star.text = mag_m_min_in;
			if(!(6.5<=mag_m_min_in && mag_m_min_in<=8.5)){
			alert("「天の川：星の等級」には6.5～8.5の半角数字を入力して下さい。");
			}
		}
	else if(isNaN(mag_m_min_in) == true){
		alert("「天の川：星の等級」には6.5～8.5の半角数字を入力して下さい。");
		}
	}

//----星像読み取り----
//星のサイズ
var textBox_star_size_min = 0;
var textBox_star_size_max = 2;
var textBox_star_size_text = "星のサイズ";
var textBox_star_size_di_j = 0;

dlg.textBox_star_size.onChanging = function(){
    var textBox_star_size_changing = error_changing (dlg.textBox_star_size.text, textBox_star_size_min , textBox_star_size_max );
        if (!(textBox_star_size_changing =="remain")){
            dlg.textBox_star_size.text = textBox_star_size_changing;
            }
}

dlg.textBox_star_size.onChange = function(){
    dlg.textBox_star_size.text = error_change (dlg.textBox_star_size.text , textBox_star_size_min , textBox_star_size_max , textBox_star_size_text  , textBox_star_size_di_j );
} 

//星の色
var textBox_star_color_min = -1.5;
var textBox_star_color_max = 6.5;
var textBox_star_color_text = "星の色";
var textBox_star_color_di_j = 0;

dlg.textBox_star_color.onChanging = function(){
    var textBox_star_color_changing = error_changing (dlg.textBox_star_color.text, textBox_star_color_min , textBox_star_color_max );
        if (!(textBox_star_color_changing =="remain")){
            dlg.textBox_star_color.text = textBox_star_color_changing;
            }
}

dlg.textBox_star_color.onChange = function(){
    dlg.textBox_star_color.text = error_change (dlg.textBox_star_color.text , textBox_star_color_min , textBox_star_color_max , textBox_star_color_text  , textBox_star_color_di_j );
} 

//----ボタン設定----
dlg.button_initialize.onClick = initialize;
dlg.button_generate.onClick = generate;
dlg.show();

//初期化ボタン関数定義
function initialize(){

        dlg.list_data_type.selection = 0;        
        dlg.textBox_comp_W.text = 297;
        dlg.textBox_comp_H.text  = 210;
        dlg.textBox_year.text = 2013;
        dlg.textBox_month.text = 7;
        dlg.textBox_day.text = 7;
        dlg.textBox_time.text = 21;
        dlg.textBox_minute.text = 30;
        dlg.textBox_longitude.text = 140;
        dlg.textBox_latitude.text = 36;
        dlg.textBox_UTC_gap_time.text = 9;
        dlg.textBox_UTC_gap_minute.text = 0;        
        dlg.textBox_dir.text = 0;
        dlg.slider_dir.value = 0;     
        dlg.textBox_star_bright.text = 2.5;
        dlg.label_star_db.text = 2.5;  
        dlg.textBox_star_dark.text = 6.5;
        dlg.textBox_milkyway_star.text = 8.5;
        dlg.textBox_star_size.text = 1;
        dlg.textBox_star_color.text = 1.5;     
        dlg.checkbox_milkyway_star.value = true;
        dlg.checkbox_milkyway_image.value = false;
        dlg.checkbox_star_color.value = true;
}


///////////////////////////////////////////
////----メインプログラム----////
///////////////////////////////////////////


//----メイン関数定義----
function generate()
{ 
     var vr_j_in = dlg.list_data_type.selection;
	var pixel_width_in = dlg.textBox_comp_W.text;
	var pixel_height_in = dlg.textBox_comp_H.text;
	var year_in = dlg.textBox_year.text;
	var month_in = dlg.textBox_month.text;
	var day_in = dlg.textBox_day.text;
	var time_h_in = dlg.textBox_time.text;
	var time_min_in = dlg.textBox_minute.text;
    var lambda_deg_in = dlg.textBox_longitude.text;
    var phi_deg_in = dlg.textBox_latitude.text;     
    var time_gap_h_in = dlg.textBox_UTC_gap_time.text; 
    var time_gap_min_in = dlg.textBox_UTC_gap_minute.text;     
	var A0_deg_in = dlg.textBox_dir.text;
	var star_laysep_mag_in = dlg.textBox_star_bright.text;     
	var mag_min_in = dlg.textBox_star_dark.text; 
    var star_milkyway_j_in = dlg.checkbox_milkyway_star.value;
    var milkyway_j_in = dlg.checkbox_milkyway_image.value;       
	var mag_m_min_in = dlg.textBox_milkyway_star.text;     
	var star_size_in = dlg.textBox_star_size.text; 
    var star_color_mag_j_in = dlg.checkbox_star_color.value;
	var star_color_mag_in = dlg.textBox_star_color.text; 
	
	if(pixel_width_in ==""){
		alert("「出力サイズW」に値を入力して下さい。");
		}	
	else if(pixel_height_in ==""){
		alert("「出力サイズH」に値を入力して下さい。");
		}
	else if(year_in ==""){
		alert("「年」に値を入力して下さい。");
		}
	else if(month_in ==""){
		alert("「月」に値を入力して下さい。");
		}
	else if(day_in ==""){
		alert("「日」に値を入力して下さい。");			
		}
	else if(time_h_in ==""){
		alert("「時間」に値を入力して下さい。");
		}
	else if(time_min_in ==""){
		alert("「分」に値を入力して下さい。");
		}        
	else if(lambda_deg_in ==""){
		alert("「経度」に値を入力して下さい。");
		}
	else if(phi_deg_in ==""){
		alert("「緯度」に値を入力して下さい。");
		}    
	else if(time_gap_h_in ==""){
		alert("「時差：時間」に値を入力して下さい。");
		}   
	else if(time_gap_min_in ==""){
		alert("「時差：分」に値を入力して下さい。");
		}      
	else if(A0_deg_in ==""){
		alert("「方角」に値を入力して下さい。");
		}
	else if(star_laysep_mag_in ==""){
		alert("「一般：明るい星」に値を入力して下さい。");
		}    
	else if(mag_min_in ==""){
		alert("「一般：暗い星」に値を入力して下さい。");
		}
	else if(mag_m_min_in ==""){
		alert("「天の川：星の等級」に値を入力して下さい。");
		}    
	else if(star_size_in ==""){
		alert("「星のサイズ」に値を入力して下さい。");
		}
	else if(star_color_mag_in ==""){
		alert("「星の色」に値を入力して下さい。");
		}    	
	else{

         vr_j_in = parseFloat(vr_j_in);
         if(vr_j_in ==0){
            pixel_width_in = parseFloat(pixel_width_in);
         }  
         else if(vr_j_in ==1){
            pixel_width_in = Math.round(pixel_width_in);
         }
         if(vr_j_in ==0){     
            pixel_height_in = parseFloat(pixel_height_in);
         }
         else if(vr_j_in ==1){     
            pixel_height_in = Math.round(pixel_height_in);
         }     
     
		year_in = Math.round(year_in);
		month_in = Math.round(month_in);
		day_in = Math.round(day_in);
		time_h_in = Math.round(time_h_in);
		time_min_in = parseFloat(time_min_in);
         lambda_deg_in = parseFloat(lambda_deg_in);
         phi_deg_in = parseFloat(phi_deg_in);     
         time_gap_h_in = Math.round(time_gap_h_in);         
         time_gap_min_in = parseFloat(time_gap_min_in);                  
		A0_deg_in = parseFloat(A0_deg_in);
		star_laysep_mag_in = parseFloat(star_laysep_mag_in);        
		mag_min_in = parseFloat(mag_min_in);
		mag_m_min_in = parseFloat(mag_m_min_in);        
		star_size_in = parseFloat(star_size_in);
		star_color_mag_in = parseFloat(star_color_mag_in);

        //入力値記憶
        UI_out = new Array();
        UI_out[0] = vr_j_in;        
        UI_out[1] = pixel_width_in;
        UI_out[2] = pixel_height_in;
        UI_out[3] = year_in;
        UI_out[4] = month_in;
        UI_out[5] = day_in;
        UI_out[6] = time_h_in;
        UI_out[7] = time_min_in;        
        UI_out[8] = lambda_deg_in;
        UI_out[9] = phi_deg_in;
        UI_out[10] = time_gap_h_in;
        UI_out[11] = time_gap_min_in;
        UI_out[12] = A0_deg_in;
        UI_out[13] = star_laysep_mag_in;
        UI_out[14] = mag_min_in;
        UI_out[15] = star_milkyway_j_in;
        UI_out[16] = mag_m_min_in;
        UI_out[17] = milkyway_j_in;      
        UI_out[18] = star_size_in;
        UI_out[19] = star_color_mag_j_in;
        UI_out[20] = star_color_mag_in;          
		
		if(!(1<=pixel_width_in && pixel_width_in<=9999)){
                  if(vr_j_in ==0){
                        alert("「出力サイズW」には1～9999の半角数字を入力して下さい。");
                  }
                  else if(vr_j_in ==1){
                        alert("「出力サイズW」には1～9999の半角整数を入力して下さい。");
                  }          
			}
		else if(!(1<=pixel_height_in && pixel_height_in<=9999)){
                  if(vr_j_in ==0){            
                        alert("「出力サイズH」には1～9999の半角数字を入力して下さい。");
                  }
                  else if(vr_j_in ==1){            
                        alert("「出力サイズH」には1～9999の半角整数を入力して下さい。");
                  }              
			}
		else if(!(1900<=year_in && year_in<=2100)){
			alert("「年」には1900～2100の半角整数を入力して下さい。");
			}
		else if(!(1<=month_in && month_in<=12)){
			alert("「月」には1～12の半角整数を入力して下さい。");
			}
		else if((month_in == 1 ||month_in == 3 || month_in == 5 ||month_in == 7 ||month_in == 8 ||month_in == 10 || month_in == 12)&& !(1<=day_in && day_in<=31)){		
			alert("「日」には1～31の半角整数を入力して下さい。");
			}		
		else if((month_in == 4 ||month_in == 6 || month_in == 9 ||month_in == 11) && !(1<=day_in && day_in<=30)){
			alert("「日」には1～30の半角整数を入力して下さい。");		
			}
		else if((month_in == 2) && !(1<=day_in && day_in<=29)){
					if(year_in%400 == 0){
							alert("「日」には1～29の半角整数を入力して下さい。");
					}
					else if(year_in%100 == 0){
							alert("「日」には1～28の半角整数を入力して下さい。");
					}
					else if(year_in%4 == 0){
							alert("「日」には1～29の半角整数を入力して下さい。");
					}
					else{
							alert("「日」には1～28の半角整数を入力して下さい。");
					}		
			}
		else if((month_in == 2) && (day_in == 29) && ( (!(year_in%400 == 0)&&(year_in%100 == 0)) || (!(year_in%4 == 0)) ) ){
			alert("「日」には1～28の半角整数を入力して下さい。");
			}
		else if(!(0<=time_h_in && time_h_in<=23)){
			alert("「時間」には0～23の半角整数を入力して下さい。");
			}
		else if(!(0<=time_min_in && time_min_in<60)){
			alert("「分」には0～60の半角数字を入力して下さい。");
			}
		else if(!(-180<=lambda_deg_in && lambda_deg_in<=180)){
			alert("「経度」には-180～180の半角数字を入力して下さい。");
			}    
		else if(!(-90<=phi_deg_in && phi_deg_in<=90)){
			alert("「緯度」には-90～90の半角数字を入力して下さい。");
			}
		else if(!(-23<=time_gap_h_in && time_gap_h_in<=23)){
			alert("「時差：時間」には-23～23の半角整数を入力して下さい。");
			}  
		else if(!(0<=time_gap_min_in && time_gap_min_in<60)){
			alert("「時差：分」には0～60の半角数字を入力して下さい。");
			}             
		else if(!(0<=A0_deg_in && A0_deg_in<=360)){
			alert("「方角」には0～360の半角数字を入力して下さい。");
			}
		else if(!(-1.5<=star_laysep_mag_in && star_laysep_mag_in<=6.5)){
			alert("「一般：明るい星」には-1.5～6.5の半角数字を入力して下さい。");
			}        
		else if(!(-1.5<=mag_min_in && mag_min_in<=6.5)){
			alert("「一般：暗い星」には-1.5～6.5の半角数字を入力して下さい。");
			}
		else if(!(star_laysep_mag_in <= mag_min_in)){
			alert("「一般：明るい星」には暗い星より小さい半角数字を入力して下さい。");
			}        
		else if(!(6.5<=mag_m_min_in && mag_m_min_in<=8.5)){
			alert("「天の川：星の等級」には6.5～8.5の半角数字を入力して下さい。");
			}        
		else if(!(0<=star_size_in && star_size_in<=2)){
			alert("「星のサイズ」には0～2の半角数字を入力して下さい。");
			}
		else if(!(-1.5<=star_color_mag_in && star_color_mag_in<=6.5)){
			alert("「星の色」には-1.5～6.5の半角数字を入力して下さい。");
			}		
	
	else {

        dlg.textBox_comp_W.text = pixel_width_in;
        dlg.textBox_comp_H.text = pixel_height_in;
        dlg.textBox_year.text = year_in;
        dlg.textBox_month.text = month_in;
        dlg.textBox_day.text = day_in;
        dlg.textBox_time.text = time_h_in;
        dlg.textBox_minute.text = time_min_in;
        dlg.textBox_longitude.text = lambda_deg_in;
        dlg.textBox_latitude.text = phi_deg_in;     
        dlg.textBox_UTC_gap_time.text = time_gap_h_in; 
        dlg.textBox_UTC_gap_minute.text = time_gap_min_in;     
        dlg.textBox_dir.text = A0_deg_in;
        dlg.textBox_star_bright.text = star_laysep_mag_in;                             
        dlg.textBox_star_dark.text = mag_min_in; 
        dlg.textBox_milkyway_star.text = mag_m_min_in;     
        dlg.textBox_star_size.text = star_size_in; 
        dlg.textBox_star_color.text = star_color_mag_in; 

//-----------------------入力値の読み取り完了-----------------------     

    //-----------入力値を計算用パラメータに代入する-----------
    
        //----データ形式----
         //出力形式の設定（0：ベクタ出力、1：ラスタ出力）
         var vr_j = vr_j_in;      

        //----出力サイズ----
		//出力画像の横方向のピクセル数
        var  pixel_width;
        if(vr_j == 0){
            pixel_width = Math.round(72/25.4*pixel_width_in);   //(mmからピクセルに変換)
        }
        else if(vr_j == 1){
            pixel_width = pixel_width_in;		
        }
    
		//出力画像の縦方向のピクセル数
        var pixel_height;
        if(vr_j == 0){
            pixel_height = Math.round(72/25.4*pixel_height_in);   //(mmからピクセルに変換)
        }
        else if(vr_j == 1){
            pixel_height = pixel_height_in;		
        }

        //----日時----
		//年月日
		var year = year_in;
		var month = month_in;
		var day = day_in;
		//時刻(24時間表記)
		var time_h = time_h_in;
		var time_min = time_min_in;

        //----場所----
		//観測地の経度(度)　東経は＋、西経は－　（参考 東京：140度）
		var lambda_deg = lambda_deg_in;
		//観測地の緯度(度)　北緯は＋、南緯は－　（参考 東京：36度）
		var phi_deg = phi_deg_in;

		//世界標準時との差
		var time_gap_h = time_gap_h_in;
		var time_gap_min = time_gap_min_in;        
         var time_gap = time_gap_h + time_gap_min/60;

        //----方位----
		//画面下方位(度)
		var A0_deg =  A0_deg_in;
		//画面下高度(度)
		var h0_deg =0;

		//画面上方位(度)
		var Ar_deg =  A0_deg;
		//画面上高度(度)
		var hr_deg =  75;

        //----一般の星----
		//最輝等級	
		var mag_max = -1.5;

        //レイヤー分けする等級（一般：明るい星）
        var star_laysep_mag = star_laysep_mag_in; 
        
		//一般：暗い星	
         var mag_min = mag_min_in;

        //----天の川----
        //天の川の星の有無（0：無し、1：有り）
        var star_milkyway_j 
            if(star_milkyway_j_in == true){
                star_milkyway_j = 1;
            }
            else if(star_milkyway_j_in == false){
                star_milkyway_j = 0;
            }        
        
        //天の川星 最微等級
        var mag_m_min = mag_m_min_in;
        		
        //天の川画像の有無（0：無し、1：有り）
        var milkyway_j 
            if((vr_j == 1) && (milkyway_j_in == true)){
                milkyway_j = 1;
            }
            else{
                milkyway_j = 0;
            }    
        
        //----星像----    
		//星のサイズ
		var star_size = star_size_in;      

         //ラスタ出力時の星の大きさ補正値
         var starimage_size = 4;

        //星の色をつける等級
        var star_color_mag;
            if(star_color_mag_j_in ==true){
                star_color_mag = star_color_mag_in;
            }
            else if(star_color_mag_j_in ==false){
                star_color_mag = mag_max;
            }
 
       
    //-----------パラメータ変換・初期設定-----------

		//度→ラジアン
		var phi_rad = phi_deg * Math.PI /180 ;
		var A0_rad = A0_deg * Math.PI /180 ;
		var h0_rad = h0_deg * Math.PI /180 ;
		var Ar_rad = Ar_deg * Math.PI /180 ;
		var hr_rad = hr_deg * Math.PI /180 ;

         //画面端計算
		var r_r;
		//var sin_theta_r = new Array();
		//var cos_theta_r = new Array();

		r_r = Math.acos( Math.sin(hr_rad)*Math.sin(h0_rad) + Math.cos(hr_rad)*Math.cos(h0_rad)*(Math.cos(Ar_rad)*Math.cos(A0_rad)+Math.sin(Ar_rad)*Math.sin(A0_rad)));
		//sin_theta_r = (Math.sin(hr_rad)*Math.cos(h0_rad) - Math.cos(hr_rad)*Math.sin(h0_rad)*(Math.cos(Ar_rad)*Math.cos(A0_rad)+Math.sin(Ar_rad)*Math.sin(A0_rad)))/(Math.sin(r_r));
		//cos_theta_r = (Math.cos(hr_rad)*(Math.sin(Ar_rad)*Math.cos(A0_rad) - Math.cos(Ar_rad)*Math.sin(A0_rad)))/(Math.sin(r_r));

		//画面上端、右端
		var yr = r_r;
		var xr = yr*((pixel_width/2)/pixel_height);      
        

		//地方恒星時算出
			//準ユリウス日
			var MJD;
			if ((month == 1) || (month == 2)){
				MJD = Math.floor(365.25*(year-1)) + Math.floor((year-1)/400) - Math.floor((year-1)/100) + Math.floor(30.59*(month+12-2)) + day 
				+1721088.5 + (time_h + time_min/60 - time_gap)/24 - 2400000.5;
				}
			else{
				MJD = Math.floor(365.25*year) + Math.floor(year/400) - Math.floor(year/100) + Math.floor(30.59*(month-2)) + day 
				+1721088.5 + (time_h + time_min/60 - time_gap)/24 - 2400000.5;
				}
			//グリニッジ恒星時
			var theta_g0 , theta_g;
			theta_g0 = 0.67239 + 1.00273781*(MJD-40000);
			theta_g = 24*(theta_g0 - Math.floor(theta_g0));
			
			//地方恒星時
			var LST , LST_deg , LST_rad;
			LST = theta_g - (-lambda_deg/15);
			if (LST < 0) {
				LST = LST + 24;
				}
			else if (LST > 24){
				LST = LST-24;
				}
			LST_deg = LST*15;
			LST_rad = LST_deg*Math.PI/180;

        //星の大きさの設定    
    		//等級差の指定
            //-1.5～-0.5
            var gm1 = 1.1;
            //-0.5～0.5
            var g0 = 1.1;
            //0.5～1.5
            var g1 = 1.3;
            //1.5～2.5
            var g2 = 1.585;
            //2.5～3.5
            var g3 = 1.585;
            //3.5～4.5
            var g4 = 1.585;
            //4.5～5.5
            var g5 = 1.585;
            //5.5～6.5
            var g6 = 1.585;
            //6.5～7.5
            var g7 = 1.585;
            //7.5～8.5
            var g8 = 1.585;


        //最小径の設定(mm)
        var dmin = 0.05;
        //最小径の設定(pixel)
        var dpmin = 0.18;
        
        var dmin_pixel;
        if(vr_j == 0){
        dmin_pixel = 72/25.4*dmin;
        }
        else if(vr_j == 1){
        dmin_pixel = dpmin;
        }  

        //各等級端点の径の計算
        star_d_mag = new Object();
        
        star_d_mag.d85 = dmin_pixel;
        star_d_mag.d75 = star_d_mag.d85*g8;
        star_d_mag.d65 = star_d_mag.d75*g7;
        star_d_mag.d55 = star_d_mag.d65*g6;
        star_d_mag.d45 = star_d_mag.d55*g5;
        star_d_mag.d35 = star_d_mag.d45*g4;
        star_d_mag.d25 = star_d_mag.d35*g3;
        star_d_mag.d15 = star_d_mag.d25*g2;
        star_d_mag.d05 = star_d_mag.d15*g1;
        star_d_mag.dm05 = star_d_mag.d05*g0;
        star_d_mag.dm15 = star_d_mag.dm05*gm1;

		//出力サイズ補正(縦480px基準)
		var drev = (pixel_height/480)*star_size;
        
        //星の色設定
        
            //色関数定義
            var setColor = function(r,g,b)
             {
             var tmpColor = new RGBColor();
             tmpColor.red = r;
             tmpColor.green = g;
             tmpColor.blue = b;
             return tmpColor;
             }        
         
            //単色
            star_color_mono = setColor(120,160,235); 
            //多色
            star_color_multi = new Object();
            
             star_color_multi.blue_Color = setColor(120,150,225);
             star_color_multi.blue_white_Color = setColor(130,150,215); 
             star_color_multi.white_Color = setColor(160,170,215);
             star_color_multi.yellow_white_Color = setColor(195,185,190); 
             star_color_multi.yellow_Color = setColor(180,170,165);
             star_color_multi.orange_Color = setColor(185,160,170); 
             star_color_multi.red_Color = setColor(190,155,190);
             
         //星の画像ファイル読み込み        
         star_image_data = new Object();
         
         star_image_data.star_blue = new File(foldername+"/star_layer_data/star_blue.png");
		star_image_data.star_blue_white = new File(foldername+"/star_layer_data/star_blue_white.png");
		star_image_data.star_white = new File(foldername+"/star_layer_data/star_white.png");
		star_image_data.star_yellow_white = new File(foldername+"/star_layer_data/star_yellow_white.png");
		star_image_data.star_yellow = new File(foldername+"/star_layer_data/star_yellow.png");
		star_image_data.star_orange = new File(foldername+"/star_layer_data/star_orange.png");
		star_image_data.star_red = new File(foldername+"/star_layer_data/star_red.png");

    //-----------カンバス作成・描画準備-----------
		//カンバス作成
         newDoc = app.documents.add(DocumentColorSpace.RGB,pixel_width,pixel_height);
         //app.activeDocument.views[0].zoom = 1;
         
delete newDoc; 

        //背景レイヤー
        var back_Color = setColor(0,0,0); //　黒色
        layerObj_back = app.activeDocument.layers;
        newLayer_back = layerObj_back.add();
        newLayer_back.name = "BACK";
        
delete layerObj_back;

        pObj_back =newLayer_back.pathItems.rectangle(pixel_height,0,pixel_width,pixel_height);
        pObj_back.filled = true; //　塗りあり
        pObj_back.stroked = false; //　線なし
        pObj_back.fillColor = back_Color; //　塗りの色を指定
        
delete pObj_back;

    //-----------天の川画像-----------
    if (milkyway_j == 1){
        ////天の川           
            //情報読み取り
                var infoFileX1  = new File(foldername+"/milkyway_data/minfo.csv");
                infoFileX1.open("r");
                var fileInfoX1 = infoFileX1.read();
                var mdeg_range = fileInfoX1.split(",");  

/*
        //--------------座標変換（間引き無し）---------------
        m_g_deg = new Object();
        m_g_deg = milkyway_transform(pixel_width , pixel_height , xr , yr , h0_rad , A0_rad , phi_rad , LST_rad , mdeg_range);
        delete Obj_m_g_deg; 
*/        
        //--------------座標変換（2pixel 間引き有り）---------------
        m_g_deg = new Object();
        m_g_deg = milkyway_transform_sample2px(pixel_width , pixel_height , xr , yr , h0_rad , A0_rad , phi_rad , LST_rad , mdeg_range);
delete Obj_m_g_deg; 
        

        //天の川配置（単色）      
        newLayer_milkyway = milkyway_place_mono(pixel_width , pixel_height , mdeg_range , m_g_deg);

/*
        //天の川配置（多色）      
      newLayer_milkyway = milkyway_place_multi(pixel_width , pixel_height , mdeg_range , m_g_deg , setColor);
*/
 
        //天の川をpng形式で保存
        newLayer_back.visible = false;         
        msave_png =  new File(foldername+"/milkyway_data/milkyway.png");
        rect = [0, pixel_height, pixel_width, 0]; // left, top, right, bottom
        opt = new ImageCaptureOptions();
        //opt.antiAliasing = true; // アンチエイリアス
        //opt.matte = false; // マットカラーなし
        opt.resolution = 72; // DPI
        opt.transparency = true; // 背景を透明にする
        activeDocument.imageCapture(msave_png, rect, opt);
        newLayer_milkyway.remove();
        newLayer_back.visible = true;

delete msave_png;
delete rect;
delete opt;

        //天の川をpng形式で配置
        layerObj_m = app.activeDocument.layers;
        newLayer_milkyway_png = layerObj_m.add();
        newLayer_milkyway_png.name = "MILKYWAY";
        mplace_png =  new File(foldername+"/milkyway_data/milkyway.png");
        myImage = app.activeDocument.placedItems.add();
        myImage.file = mplace_png;
        myImage.embed();//画像の埋め込み
        
         mObj = activeDocument.layers["MILKYWAY"];
         mObj.opacity = 30;
         
         //mplace_png.remove();//天の川ファイルの削除
         
delete layerObj_m;
delete mplace_png;
delete myImage;
delete mObj;

    }

    //-----------天の川用の星-----------
    if (star_milkyway_j == 1){
        //座標変換、配置
        newLayer_star_m = star_milkyway_transform_and_place(star_color_mono , mag_m_min , star_d_mag , drev , LST_rad , phi_rad , h0_rad , hr_rad , A0_rad , xr , yr , pixel_width , pixel_height);
    } 

    //-----------一般の星-----------		      
        //座標変換、配置
        star65_transform_and_place(mag_max , mag_min , star_d_mag , drev , LST_rad , phi_rad , h0_rad , hr_rad , A0_rad , xr , yr , pixel_width , pixel_height , star_color_mono , star_color_multi , star_image_data , starimage_size , vr_j , star_laysep_mag , star_color_mag);
        

    //-----------後処理-----------
    
        //UI前回入力値書き出し
        UIFileX1.open("w");
        UIFileX1.write(UI_out);
        UIFileX1.close();
      
        //1番下の空レイヤーの削除
        layObj_bottom = activeDocument.layers;
        var lay_number = layObj_bottom.length;
        layObj_bottom[lay_number-1].remove();

delete layObj_bottom;

		dlg.close(); 	//ウィンドウを閉じる

delete star_d_mag;
delete star_color_mono;
delete star_color_multi;
delete star_image_data;

delete newLayer_back;
delete newLayer_milkyway;
delete newLayer_milkyway_png;
delete newLayer_star_m;

delete UIFileX1;
delete UI_in;
delete UI_out;

		}
	}
}
//-----------メイン関数ここまで-----------

})();
